using System;
using System.Collections.Generic;
using System.Text;

namespace RazredDereza
{
    public class Dereza
    {
        /// <summary>
        /// privatne spremenljivke, uporabnik jih lahko spreminja samo preko metod
        /// </summary>
        private string proizvajalec;
        private int steviloZob;
        private double cena;
        private int teza;
        /// <summary>
        /// osnovni konstruktor
        /// </summary>
        public Dereza()
        {
            this.proizvajalec = "Grivel";
            this.steviloZob = 12;
            this.cena = 200.0;
            this.teza = 200;
        }
        /// <summary>
        /// konstruktor z danimi vrednostmi, vrednosti kontroliramo preko metod
        /// </summary>
        /// <param name="proizv"></param>
        /// <param name="stZob"></param>
        /// <param name="cen"></param>
        /// <param name="tez"></param>
        public Dereza(string proizv, int stZob, double cen, int tez): this()
        {
            this.NastaviProiz(proizv);
            this.NastaviStZob(stZob);
            this.NastaviCeno(cen);
            this.NastaviTezo(tez);
        }
        /// <summary>
        /// set metode
        /// </summary>
        /// <param name="proizv">če je proizv "" ali null se ime proizv ne spremeni</param>
        public void NastaviProiz(string proizv)
        {
            if (proizv !="" && proizv !=null)
            {
                this.proizvajalec = proizv;
            }
        }
        /// <summary>
        ///
        /// </summary>
        /// <param name="stZob">število zob smo nastavili med 4 in 14</param>
        public void NastaviStZob(int stZob)
        {
            if (stZob >=4  && stZob <=14)
            {
                this.steviloZob = stZob;
            }
        }
        /// <summary>
        ///
        /// </summary>
        /// <param name="cen">ceno smo nastavili med 35 in 400 evrov</param>
        public void NastaviCeno(double cen)
        {
            if (cen >= 35 && cen <= 400)
            {
                this.cena = cen;
            }
        }
        /// <summary>
        ///
        /// </summary>
        /// <param name="tez">težo smo nastavili med 160 in 1400 grami</param>
        public void NastaviTezo(int tez)
        {
            if (tez >= 160 && tez <=1400)
            {
                this.teza = tez;
            }
        }

        public string VrniProizv()
        {
            return this.proizvajalec;
        }
        /// <summary>
        /// get metode
        /// </summary>
        /// <returns></returns>
        public int VrniStZob()
        {
            return this.steviloZob;
        }

        public double VrniCeno()
        {
            return this.cena;
        }

        public int VrniTezo()
        {
            return this.teza;
        }
        /// <summary>
        /// vrne smiseln niz, ki predstavlja opis objekta
        /// </summary>
        /// <returns></returns>
        public string Opis()
        {
            return "Dereza proizvajalca " + this.VrniProizv() + " ima " + this.VrniStZob() + " zob," +
                    " stane " + this.VrniCeno() + " EUR, in tehta " + this.VrniTezo() + " g.";
        }



    }
}</csharp>

Testni program
<csharp>using System;
using System.Collections.Generic;
using System.Text;
using RazredDereza;

namespace DerezaTest
{
    class Program
    {
        static void Main(string[] args)
        {
            //ustvarimo nekaj derez
            Dereza prva = new Dereza("Black", 7, 250.45, 1150);
            Console.WriteLine("DEREZA1:" + prva.Opis());

            //dereza z nepravilnimi podatki
            Dereza druga = new Dereza("Cammp", -4, 90, 12160);
            Console.WriteLine("\nDEREZA2:" + druga.Opis());
            //z metodami popravimo podatke
            druga.NastaviStZob(10);
            druga.NastaviTezo(280);
            Console.WriteLine("DEREZA2:" + druga.Opis());

            Dereza tretja = new Dereza("Cassin", 8, 130.5, 1250);
            Console.WriteLine("\nDEREZA3:" + tretja.Opis());

            //še ena dereza z nepravilnim podatki
            Dereza cetrta = new Dereza("", 6, -170, 320);
            Console.WriteLine("\nDEREZA4:" + cetrta.Opis());
            //popravimo podatke
            cetrta.NastaviProiz("Escim");
            cetrta.NastaviCeno(225.4);
            Console.WriteLine("DEREZA4:" + cetrta.Opis());

            Dereza peta = new Dereza("Petzl", 14, 240, 590);
            Console.WriteLine("\nDEREZA5:" + peta.Opis());
            Dereza sesta = new Dereza("Aptel", 11, 140.25, 720);
            Console.WriteLine("DEREZA6:" +  sesta.Opis());

            //shranimo derze v tabelo
            Dereza[] tabDereza = new Dereza[6];
            tabDereza[0] = new Dereza(prva.VrniProizv(), prva.VrniStZob(), prva.VrniCeno(), prva.VrniTezo());
            tabDereza[1] = new Dereza(druga.VrniProizv(), druga.VrniStZob(), druga.VrniCeno(), druga.VrniTezo());
            tabDereza[2] = new Dereza(tretja.VrniProizv(), tretja.VrniStZob(), tretja.VrniCeno(), tretja.VrniTezo());
            tabDereza[3] = new Dereza(cetrta.VrniProizv(), cetrta.VrniStZob(), cetrta.VrniCeno(), cetrta.VrniTezo());
            tabDereza[4] = new Dereza(peta.VrniProizv(), peta.VrniStZob(), peta.VrniCeno(), peta.VrniTezo());
            tabDereza[5] = new Dereza(sesta.VrniProizv(), sesta.VrniStZob(), sesta.VrniCeno(), sesta.VrniTezo());

            //poiščemo derezo z najboljšim razmerjem med težo in ceno
            int i = 0;
            double najbRazm = tabDereza[0].VrniCeno() * tabDereza[0].VrniTezo();
            string izpis = "";
            while (i < tabDereza.Length)
            {
                //poiščemo najmanši produkt cene in teže dereze
                if (tabDereza[i].VrniCeno() * tabDereza[i].VrniTezo() < najbRazm)
                {
                     najbRazm = tabDereza[i].VrniCeno()* tabDereza[i].VrniTezo();
                     izpis = ("NAJBOLJŠE RAZMERJE MED TEŽO IN CENO:" + tabDereza[i].Opis());
                }
                i = i + 1;
            }

            //derezo z najboljšim razmerjem izpišemo na zaslon
            Console.WriteLine("\n" + izpis);
            Console.Write("\nZa konec pritisni katero koli tipko...");
            Console.ReadLine();
        }

    }
}